var BS_POINT=1;
var BS_SMALLSQUARE=2;
var BS_BIGSQUARE=3;
var BS_RHOMB=4;
var BS_CIRCLE=5;
var BS_SLASH=6;
var BS_BACKSLASH=7;
var BS_HORLINE=8;
var BS_VERLINE=9;
var BS_CROSS=10;
var arrBS=new Array('point','smallsquare','bigsquare','rhomb','circle','slash','backslash','horline','verline','cross');

var jg;
var fl=false;
var penColor;
var brushStyle;
var color_tool;
var brush_tool;

function refreshMain()
{
	SetPenColor(color_tool,penColor);
	SetBrushStyle(brush_tool,brushStyle);
}

function paint()
{
	var x,y;
	jg.setColor(penColor); // green
	x=window.event.clientX-parseInt(canvas.style.left,10);
	y=window.event.clientY-parseInt(canvas.style.top,10);
	switch(brushStyle)
		{
			case BS_POINT:
			default:
				if(x>=0&&y>=0&&x<=106&&y<=106)
					jg.drawLine(x,y,x,y);
				break;
			case BS_SMALLSQUARE:
				if((x-1)>=0&&(y-1)>=0&&(x+1)<=106&&(y+1)<=106)
					jg.fillRect(x-1, y-1, 3, 3);
				break;
			case BS_BIGSQUARE:
				if((x-2)>=0&&(y-2)>=0&&(x+2)<=106&&(y+2)<=106)
					jg.fillRect(x-2, y-2, 5, 5);
				break;
			case BS_RHOMB:
				if((x-2)>=0&&(y-2)>=0&&(x+2)<=106&&(y+2)<=106)
					jg.fillPolygon(new Array(x-2,x,x+2,x), new Array(y,y-2,y,y+2));
				break;
			case BS_CIRCLE:
				if((x-2)>=0&&(y-2)>=0&&(x+2)<=106&&(y+2)<=106)
					jg.fillEllipse(x-2,y-2,5,5);
				break;
			case BS_SLASH:
				if((x-1)>=0&&(y-1)>=0&&(x+1)<=106&&(y+1)<=106)
					jg.drawLine(x+1,y-1,x-1,y+1);
				break;
			case BS_BACKSLASH:
				if((x-1)>=0&&(y-1)>=0&&(x+1)<=106&&(y+1)<=106)
					jg.drawLine(x-1,y-1,x+1,y+1);
				break;
			case BS_HORLINE:
				if((x-1)>=0&&y>=0&&(x+1)<=106&&y<=106)
					jg.drawLine(x-1,y,x+1,y);
				break;
			case BS_VERLINE:
				if(x>=0&&(y-1)>=0&&x<=106&&(y+1)<=106)
					jg.drawLine(x,y-1,x,y+1);
				break;
			case BS_CROSS:
				if((x-1)>=0&&(y-1)>=0&&(x+1)<=106&&(y+1)<=106)
					{
					jg.drawLine(x-1,y,x+1,y);
					jg.drawLine(x,y-1,x,y+1);
					}
				break;
		}
	jg.paint();
}

function ClearCanvas()
{
	jg.clear();
}

function SetPenColor(color_tool,color)
{
	var els=document.getElementsByTagName('span');
	for(var i=0;i<els.length;i++)
		{
			if(els[i].id.substr(0,5)=='color')
				els[i].style.border='none';
		}
	color_tool.style.border='1px solid #b4b4b4';
	penColor=color;
	saveSettings();
}
function SetBrushStyle(brush_tool,style)
{
	var els=document.getElementsByTagName('span');
	for(var i=0;i<els.length;i++)
		{
			if(els[i].id.substr(0,5)=='brush')
				els[i].style.border='none';
		}
	brush_tool.style.border='1px solid #b4b4b4';
	brushStyle=style;
	saveSettings();
}

function saveSettings()
{
	System.Gadget.Settings.write("SettingsExist", true);
	System.Gadget.Settings.writeString("PenColor", escape(penColor));
	System.Gadget.Settings.write("BrushStyle", brushStyle);
}

function loadMain()
{
	System.Gadget.visibilityChanged = visibilityChanged;
	jg = new jsGraphics("canvas");
	jg.setPrintable(false);
	if (System.Gadget.Settings.read("SettingsExist"))
		{
		var els=document.getElementsByTagName('span');
		penColor=unescape(System.Gadget.Settings.readString("PenColor"));
		for(var i=0;i<els.length;i++)
			{
				if(els[i].id==('color_'+penColor.substr(1,6)))
					{
						color_tool=els[i];
						break;
					}
			}
		brushStyle=parseInt(System.Gadget.Settings.read("brushStyle"),10);
		for(var i=0;i<els.length;i++)
			{
				if(els[i].id==('brush_'+arrBS[brushStyle-1]))
					{
						brush_tool=els[i];
						break;
					}
			}
		}
	else
		{
		penColor='#000000';
		color_tool=color_000000;
		brushStyle=BS_POINT;
		brush_tool=brush_point;
		}
}

function visibilityChanged()
{
	if (System.Gadget.visible)
	{
		refreshMain();
	}
}
